#ifndef __COSMOE_IO_H__
#define __COSMOE_IO_H__


#ifdef SLOW_IO_BY_JUMPING
#define __SLOW_DOWN_IO "\njmp 1f\n1:\tjmp 1f\n1:"
#else
#define __SLOW_DOWN_IO "\noutb %%al,$0x80"
#endif

#ifdef REALLY_SLOW_IO
#define __FULL_SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO __SLOW_DOWN_IO
#else
#define __FULL_SLOW_DOWN_IO __SLOW_DOWN_IO
#endif


static inline void outb_p(unsigned char value, unsigned short port)
{
	__asm__ volatile
	(
		"outb %b0,%w1\n"
		"outb %%al,$0x80" : : "a" (value), "Nd" (port)
	);
} 


#endif /* ndef __COSMOE_IO_H__ */
